HDU King (非连通图的差分约束,经典好题)

King

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 2216    Accepted Submission(s): 999
Once, in one kingdom, there was a queen and that queen was expecting a baby. The queen prayed: ``If my child was a son and if only he was a sound king.'' After nine months her child was born, and indeed, she gave birth to a nice son. 
Unfortunately, as it used to happen in royal families, the son was a little retarded. After many years of study he was able just to add integer numbers and to compare whether the result is greater or less than a given integer number. In addition, the numbers had to be written in a sequence and he was able to sum just continuous subsequences of the sequence. 

The old king was very unhappy of his son. But he was ready to make everything to enable his son to govern the kingdom after his death. With regards to his son's skills he decided that every problem the king had to decide about had to be presented in a form of a finite sequence of integer numbers and the decision about it would be done by stating an integer constraint (i.e. an upper or lower limit) for the sum of that sequence. In this way there was at least some hope that his son would be able to make some decisions. 

After the old king died, the young king began to reign. But very soon, a lot of people became very unsatisfied with his decisions and decided to dethrone him. They tried to do it by proving that his decisions were wrong. 

Therefore some conspirators presented to the young king a set of problems that he had to decide about. The set of problems was in the form of subsequences Si = {aSi, aSi+1, ..., aSi+ni} of a sequence S = {a1, a2, ..., an}. The king thought a minute and then decided, i.e. he set for the sum aSi + aSi+1 + ... + aSi+ni of each subsequence Si an integer constraint ki (i.e. aSi + aSi+1 + ... + aSi+ni < ki or aSi + aSi+1 + ... + aSi+ni > ki resp.) and declared these constraints as his decisions. 

After a while he realized that some of his decisions were wrong. He could not revoke the declared constraints but trying to save himself he decided to fake the sequence that he was given. He ordered to his advisors to find such a sequence S that would satisfy the constraints he set. Help the advisors of the king and write a program that decides whether such a sequence exists or not. 

InputThe input consists of blocks of lines. Each block except the last corresponds to one set of problems and king's decisions about them. In the first line of the block there are integers n, and m where 0 < n <= 100 is length of the sequence S and 0 < m <= 100 is the number of subsequences Si. Next m lines contain particular decisions coded in the form of quadruples si, ni, oi, ki, where oi represents operator > (coded as gt) or operator < (coded as lt) respectively. The symbols si, ni and ki have the meaning described above. The last block consists of just one line containing 0.OutputThe output contains the lines corresponding to the blocks in the input. A line contains text successful conspiracy when such a sequence does not exist. Otherwise it contains text lamentable kingdom. There is no line in the output corresponding to the last ``null'' block of the input.Sample Input

4 2
1 2 gt 0
2 2 lt 2
1 2
1 0 gt 0
1 0 lt 0
0

Sample Output

lamentable kingdom
successful conspiracy

题目很长,意思是:有一个长度为n的序列和它的m个子序列。每一个子序列的和都有一个k来约束。gt代表大于k,lt代表小于k。问是否存在这个长度为n的序列。

 

让我们来思考这道题,首先对于给出的每个子序列我们可以看成子序列尾部到原序列起点的和减去子序列起点前一位到原序列起点的和。

例如:原序列为a[1]+a[2]+.....a[s]+...a[n]+a[n+1]+...... 子序列a[s]+....+a[n]=S[n]-S[s-1];

 

这样我们可以把S[n], S[s-1]看成两点,约束值k就可以看成对这两点间权大小和方向的约束。 按照上述过程可以建立起表示S[]点间关系的图。则就把问题转化为了最短路径问题。

 

若这个序列存在,则S[i]到图中任意一点都有最短路径,则图中不存在负环。所以判断是否存在序列就是判断是否存在负环。

 

好,具体思路清楚了,我们来研究如何建立起图。题中给出的约束条件有 > 和 < 。我们要做的事是将所有的约束条件全部转化为<= 。 即建立差分约束系统

 

 

分析:

我们令S[i]= a1+a2+..+ai. 所以对于每一条约束条件比如:

a[si]+a[si+1]+…+a[si+ni]< ki . 我们可以转化为 S[si+ni] – S[si-1] <= ki-1.

这样就可以转化为了差分约束系统了.

该系统具有点的集合为0, 1,… n.其中对于S[si+ni] – S[si-1] <= ki-1条件我们可以得到 si-1 到 si+ni 的权值为ki-1的边.

对于a[si]+a[si+1]+…+a[si+ni] >ki 即 S[si+ni] – S[si-1] >=ki+1 我们可以得到 si+ni 到 si-1 的权值为-ki-1 的边.


而在判断差分约束系统是否有解时,建立的路径图可能不是连通的。因此我们还需要虚构一个超级源n+1号点.使得从n+1号点有边出来到0,1,…n号点且权值为0.

注意:图中原有的点是0到n共n+1个点

第一次讨论差分约束系统问题,若叙述有误,请各位指出。

 

具体代码如下:

#include<algorithm>
#include<iostream>
#include<cstdlib>
#include<cstring>
#include<cstdio>
#include<cmath>
#include<queue>
#include<stack>
#include<map>
#include<set>
#define maxn 110
#define maxm 10010
#define inf 0x3f3f3f
using namespace std;
int n,m;
struct node
{
    int to;
    int next;
    int c;
}edge[maxn];
int head[maxn];
int mark[maxn];
int cnt=0;
void add(int u,int v,int c)
{
    edge[cnt].next=head[u];
    edge[cnt].to=v;
    edge[cnt].c=c;
    head[u]=cnt++;
}
int dis[maxn];
bool visit[maxn];//记录是否在队列中
void spfa()
{
    queue<int>q;
    for(int i=0;i<=n+1;i++)
    {
        dis[i]=inf;
        visit[i]=0;
        mark[i]=0;
    }
    dis[n+1]=0;
    visit[n+1]=1;
    mark[n+1]++;
    q.push(n+1);
    while(!q.empty())
    {
        int u=q.front();
        q.pop();
        visit[u]=0;
        for(int i=head[u];i!=-1;i=edge[i].next)
        {
            int v=edge[i].to;
            if(dis[v]>dis[u]+edge[i].c)
            {
                dis[v]=dis[u]+edge[i].c;
                if(!visit[v])
                {
                    q.push(v);
                    visit[v]=1;
                    mark[v]++;
                    if(mark[v]>n+1)
                    {
                        printf("successful conspiracy
");
                        return;
                    }
                }
            }
        }
    }
    printf("lamentable kingdom
");
}

int main()
{
    while(cin>>n&&n)
    {
        cin>>m;
        char s[3];
        int u,v,c;
        cnt=0;
        memset(head,-1,sizeof(head));
        for(int i=1;i<=m;i++)
        {
            scanf("%d%d%s%d",&u,&v,&s,&c);
            if(s[0]=='g')
            {
                add(u+v,u-1,-(c+1));
            }
            else if(s[0]=='l')
            {
                add(u-1,u+v,c-1);
            }
        }
        for(int i=0;i<=n;i++)
        {
            add(n+1,i,0);
        }
        spfa();
    }
    return 0;
}
原文地址:https://www.cnblogs.com/caiyishuai/p/9547829.html